<?php

/*
 * PHP versions 4 and 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   Adressbook
 * @package    QuickTeam
 * @author     Philippe Vandenberghe <info@qt-cute.org>
 * @copyright  2008-2012 The PHP Group
 * @license    http://www.php.net/license  PHP License 3.0
 * @version    1.9.0.3 build:20081001
 * @link       http://www.qt-cute/doc/package/qte
 * @since      File available since Release 1.0.0
 * @deprecated File deprecated in Release 2.0.0
 *
 */

session_start();
require_once('bin/qte_init.php');
include(Translate('qte_lang_adm.inc'));
include(Translate('qtem_import.inc'));
if ( $oVIP->role!='A' ) die($L['E_admin']);

// INITIALISE

$strTitle   = '';
$strFormat  = 'CSV';
$strDelimit = ';';
$strEnclose = '"';
$strNull    = 'NULL';
$strSkip    = 'N';
$intSection = -1;

$oVIP->selfurl = 'qtem_import_adm.php';
$oVIP->selfname = $L['import']['Admin'];
$oVIP->exiturl = $oVIP->selfurl;
$oVIP->exitname = $oVIP->selfname;
$strPageversion = $L['import']['Version'].' 1.9<br/>';

// --------
// SUBMITTED
// --------

if ( isset($_POST['ok']) )
{
  // check file
  if (!is_uploaded_file($_FILES['title']['tmp_name'])) $qte_error = $L['import']['E_nofile'];

  // check form value
  if ( empty($qte_error) )
  {
    $strFormat = trim($_POST['format']);
    $strDelimit = trim($_POST['delimit']);
    if ( $strFormat=='SQL' ) $strDelimit = ',';
    $strEnclose = trim($_POST['enclose']);  if ( get_magic_quotes_gpc() ) $strEnclose = stripslashes($_POST['enclose']);
    $strNull = trim($_POST['null']);
    if ( isset($_POST['skip']) ) $strSkip='Y';
    if ( empty($strDelimit) ) $qte_error=$L['export']['Delimiter'].S.$L['E_invalid'];
    $intSection = intval($_POST['section']);
    $_SESSION['m_import']=array($strTitle,$strFormat,$strDelimit,$strEnclose,$strNull,$strSkip,$intSection);
  }

  // check values
  if ( empty($qte_error) )
  {
    if ( strlen($strDelimit)==1 )
    {
    if ( ereg("[0-9A-Za-z]",$strDelimit) ) $qte_error=$L['export']['Delimiter'].S.$L['E_invalid'];
    if ( $_SESSION['m_export']['delimit']=='.' ) $qte_error=$L['export']['Delimiter'].S.$L['E_invalid'];
    }
    if ( strlen($strEnclose)==1 )
    {
    if ( ereg("[0-9A-Za-z]",$strEnclose) ) $qte_error=$L['export']['Enclose'].S.$L['E_invalid'];
    if ( $_SESSION['m_export']['enclose']=='.' ) $qte_error=$L['export']['Enclose'].S.$L['E_invalid'];
    }
  }

  // save and run
  if ( empty($qte_error) )
  {
    if ( empty($_POST['null']) ) { $strNull=S; } else { $strNull=$_POST['null']; }

    if ( $_FILES['title']['type']!='text/plain' )
    {
    $qte_error = $L['import']['E_format'];
    unlink($_FILES['title']['tmp_name']);
    }

    // read lines
    $handle = fopen($_FILES['title']['tmp_name'],'r');
    if ( $handle )
    {
      if ( $strSkip=='Y' ) $str = fgets($handle);

      // -----
      $i = 0;
      $intCount = 0;
      $intNextid = Nextid(TABUSER);

      while ( !feof($handle) )
      {
        $i++;
        $str = fgets($handle);
        if ( strlen($str)<4 ) continue;

        if ( $strFormat=='SQL' )
        {
        $str = trim(strstr($str,'VALUES ('));
        $str = substr($str, 8, -1);
        }

        // import line
        if ( substr_count($str, $strDelimit)>35 )
        {
          $arrStr = explode($strDelimit,$str);

          if ( count($arrStr)==38 )
          {
            // pre-process values, remove encloser, html quote (skip #1, the id)
            For ($j=1;$j<38;$j++)
            {
              $arrStr[$j]=trim($arrStr[$j]);
              if ( substr($arrStr[$j],0,1)==$strEnclose && substr($arrStr[$j],-1,1)==$strEnclose ) $arrStr[$j]=substr($arrStr[$j],1,-1);
              $arrStr[$j] = htmlspecialchars($arrStr[$j],ENT_QUOTES);
              if ( $arrStr[$j]==$strNull ) { $arrStr[$j]='NULL'; } else { $arrStr[$j]='"'.$arrStr[$j].'"'; }
            }
            $arrStr[0]=$intNextid;            
            $oDB->Query( 'INSERT INTO '.TABUSER.' (id,username,pwd,role,type,status,children,title,firstname,midname,lastname,alias,birthdate,nationality,sexe,picture,address,phones,emails,www,privacy,signature,descr,firstdate,teamid1,teamid2,teamrole1,teamrole2,teamdate1,teamdate2,teamvalue1,teamvalue2,teamflag1,teamflag2,x,y,z,ip) VALUES ('.implode(',',$arrStr).')' );
            $oDB->Query( 'INSERT INTO '.TABS2U.' (sid,userid,issuedate) VALUES ('.$intSection.','.$intNextid.',"'.date('Ymd').'")' );
            $intCount++;
            $intNextid++;
          }
          else
          {
            $qte_error='Number of parameters ('.count($arrStr).') not matching in line '.$i;
          }
        }
        else
        {
        $qte_error='Not enough delimiters ('.substr_count($str, $strDelimit).') in line '.$i;
        }
      }
      // ----
      fclose($handle);

      // udate stats
      if ( $intCount>0 )
      {
      cSection::UpdateStats($intSection);
      }
    }
  }

  if ( empty($qte_error) )
  {
    unlink($_FILES['title']['tmp_name']);
    $oVIP->EndMessage(NULL,$L['import']['S_import'].' '.LangS('User',$intCount),'admin',0);
  }
}

// --------
// HTML START
// --------

include('qte_adm_p_header.php');
include('qte_adm_p_title.php');

if ( isset($_SESSION['m_import']) )
{
$strTitle   = $_SESSION['m_import'][0];
$strFormat  = $_SESSION['m_import'][1];
$strDelimit = $_SESSION['m_import'][2];
$strEnclose = $_SESSION['m_import'][3];
$strNull    = $_SESSION['m_import'][4];
$strSkip    = $_SESSION['m_import'][5];
$intSection   = $_SESSION['m_import'][6];
}

echo '
<script type="text/javascript">
<!--
function ValidateForm(theForm)
{
  if (theForm.title.value.length==0) { alert(html_entity_decode("',$L['E_mandatory'],': File")); return false; }
  return null;
}
-->
</script>
';

echo '<form method="post" action="',$oVIP->selfurl,'" enctype="multipart/form-data" onsubmit="return ValidateForm(this);">
<input type="hidden" name="maxsize" value="5242880"/>
<table class="ta" cellspacing="0">
';
echo '<tr class="tr">
<th class="th_o th_o_all" colspan="2">',$L['import']['File'],'</th>
</tr>
';
echo '<tr class="tr">
<th class="th_o th_o_first" style="width:200px"><label for="title">',$L['import']['File'],'</label></th>
<td class="td_o"><input type="file" id="title" name="title" size="32" value="',$strTitle,'"/></td>
</tr>
';
echo '<tr class="tr">
<th class="th_o th_o_all" colspan="2">',$L['Adm_settings'],'</th>
</tr>
';
echo '<tr class="tr">
<th class="th_o th_o_first"><label for="format">',$L['import']['Format'],'</label></th>
<td class="td_o"><select id="format" name="format">
<option value="CSV"',($strFormat=='CSV' ? QSEL : ''),'>',$L['import']['Csv'],'</option>
<option value="SQL"',($strFormat=='SQL' ? QSEL : ''),'>',$L['import']['Sql'],'</option>
</select></td>
</tr>
';
echo '<tr class="tr">
<th class="th_o th_o_first"><label for="delimit">',$L['import']['Delimiter'],'</label></th>
<td class="td_o"><input type="text" id="delimit" name="delimit" size="1" maxlength="5" value="',$strDelimit,'"/></td>
</tr>
';
echo '<tr class="tr">
<th class="th_o th_o_first"><label for="enclose">',$L['import']['Encloser'],'</label></th>
<td class="td_o"><input type="text" id="enclose" name="enclose" size="1" maxlength="5" value="',htmlspecialchars($strEnclose),'"/></td>
</tr>
';
echo '<tr class="tr">
<th class="th_o th_o_first"><label for="null">',$L['import']['Null'],'</label></th>
<td class="td_o"><input type="text" id="null" name="null" size="5" maxlength="24" value="',$strNull,'"/> ',$L['import']['H_Null'],'</td>
</tr>
';
echo '<tr class="tr">
<th class="th_o th_o_first">',$L['import']['First_line'],'</th>
<td class="td_o"><input type="checkbox" id="skip" name="skip"',($strSkip=='Y' ? QCHE : ''),'/><label for="skip">',$L['import']['HFirst_line'],'</label></td>
</tr>
';
echo '<tr class="tr">
<th class="th_o th_o_all" colspan="2">',$L['Destination'],'</th>
</tr>
';
echo '<tr class="tr">
<th class="th_o th_o_first" style="width:200px"><label for="section">',$L['import']['Destination'],'</label></th>
<td class="td_o"><select id="section" name="section">',QTastags(GetSectionTitles('A')),'</select> <a href="qte_adm_sections.php">',$L['Section_add'],'</a></td>
</tr>
';
echo '<tr class="tr">
<th class="th_o th_o_all" colspan="2" style="padding:6px; text-align:center"><input type="submit" name="ok" value="',$L['Ok'],'"/></th>
</tr>
';
echo '</table>
</form>
';

// HTML END

include('qte_adm_p_footer.php');

?>