<?php

/*
 * PHP versions 4 and 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   Adressbook
 * @package    QuickTeam
 * @author     Philippe Vandenberghe <info@qt-cute.org>
 * @copyright  2008-2012 The PHP Group
 * @license    http://www.php.net/license  PHP License 3.0
 * @version    1.9.0.3 build:20081001
 * @link       http://www.qt-cute/doc/package/qte
 * @since      File available since Release 1.0.0
 * @deprecated File deprecated in Release 2.0.0
 *
 */

session_start();
require_once('bin/qte_init.php');
include(Translate('qte_lang_adm.inc'));
if ( $oVIP->role!='A' ) die($L['E_admin']);

// INITIALISE

$strVersion='v1.9';

include(Translate($_SESSION[QT]['language'],'qte_lang_adm.inc'));

$oVIP->selfurl = 'qtem_import_install.php';
$oVIP->selfname = 'Installation module IMPORT '.$strVersion;

$bStep1 = true;
$bStep2 = true;

// STEP 1

if ( empty($qte_error) )
{
  $strFile = 'qtem_import_adm.php';
  if ( !file_exists($strFile) ) $qte_error="Missing file: $strFile. Check installation instructions.<br/>This module cannot be used.";
  if ( !empty($qte_error) ) $bStep1 = false;
}

// STEP 2

if ( empty($qte_error) )
{
  $oDB->Query('DELETE FROM '.TABSETTING.' WHERE param="module_import"');
  $oDB->Query('INSERT INTO '.TABSETTING.' (param,setting) VALUES ("module_import","Import")');
}

// --------
// Html start
// --------
include('qte_adm_p_header.php');

echo '
<h1>',$oVIP->selfname,'</h1>
';

echo '<h2>Checking components</h2>';
if ( !$bStep1 )
{
  echo '<p class="error">',$qte_error,'</p>';
  include('qte_adm_p_footer.php');
  exit;
}
echo '<p>Ok</p>';
echo '<h2>Database settings</h2>';
echo '<p>Ok</p>';
echo '<h2>Installation completed</h2>';

include('qte_adm_p_footer.php');

?>
